package no.ntnu.idatt1002.demo.data.Budget;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

//Disable next i dualList før income har blitt lagt til. Kanksje filter som prevneter negativ max amount (if balance < 1)
//MÅTE Å FIKSE TESTER PÅ: LA SELECTEDBUDGET.CURRENT VÆRE EN PARAMETER I METODENE
//Disable next i newBudgetbert til maxamount har blitt burkt opp
//Sette label til total balance i dualList
//HVIS CONTINUE I BUDGET PRESSES, SHOWCONFIRMATION
//VIKTIG_ BALANCE LABEL ER RØD PÅ GRØNN BAKGRUNN!!!
//Binde label to total balance i budget window (newBUdgetBert)
//Popup for edit og delete button
//La next button save dataene i to nye filer for persisterign i tilfelle "back" trykkes i newBudgetbudget
//confirmation for når returnBtn som returner til start. "Are you sure you want to go back. Changes will not be saved"
// FIKSE TRY CATCHES I ALLE METODENE!!!!!!!!!!
//tester for nye klasserr
//resize fordi tabellkolonner er for små, fontsize, font
//set all windows unresizable
//Bytte oversikt på dualList til Monthly ....

//System.out.println(System.getProperty("user.dir") + path); =
//C:\Users\xulr0\IdeaProjects\skoleProsjekter\idatt1002\idatt1002_2023_9src/main/resources/

//(System.getProperty("user.dir") + "/" + path) =
//(path) =
//(src/main/resources)
public class FileHandlingBudgetArchive {
  private static final String filePath = "src/main/resources/budgets/";
  private static final String fileType = ".archive";

  public static void writeBudgetRegisterToArchive(BudgetRegister budgetNames) throws IOException {
    try (BufferedWriter bw = new BufferedWriter(new FileWriter(filePath + "Archive" + fileType))) {
      bw.write(budgetNames.toString());
    } catch (IOException ioe) {
      ioe.printStackTrace();
      throw new IOException("Could not write to file: Archive", ioe);
    }
  }

  public static boolean isBudgetRegisterEmpty() throws IOException {
    try (BufferedReader br = new BufferedReader(new FileReader(filePath
        + "Archive" + fileType))) {
      return br.readLine() == null;
    }
  }
  public static BudgetRegister readBudgetArchive(String fileTitle) throws IOException {
    BudgetRegister budgetRegister = null;
    String budgetName;
    String line;

    try (BufferedReader br = new BufferedReader(
        new FileReader(filePath + "Archive" + fileType))) {

      String nextLine = br.readLine();
      while ((line = nextLine) != null) {
        System.out.println(line);
        nextLine = br.readLine();
        budgetName = line;

        if (budgetRegister == null) {
          budgetRegister = new BudgetRegister();
        }
        budgetRegister.addBudgetName(budgetName);
      }
    }
    return budgetRegister;
  }

  public static void writeSavingsToFile() {

  }

  public static boolean deleteBudgetDirectory(String budgetID) {
    File targetDirectory = new File(filePath + budgetID);
    System.out.println("Deleting directory:" + targetDirectory.getPath());

    String[]entries = targetDirectory.list();
    assert entries != null;
    for(String file : entries){
      File currentFile = new File(targetDirectory.getPath(),file);
      System.out.println("Deleting file:" + currentFile.delete());
    }

    return targetDirectory.delete();
  }
}
